from turtle import *
from turtleBeads import *

import random

colors = ["LightSkyBlue", "LightPink", "LightSeaGreen", "PaleVioletRed"]

def gridCoordinates(row, col, radius):
    cellSize = 2*radius
    return (cellSize*col, cellSize*row) # note that column -> x and row -> y

def blueCircleGrid(width, height, radius):
    for row in range(height):
        for col in range(width):
            x, y = gridCoordinates(row, col, radius)
            color("LightSkyBlue")
            teleport(x, y)
            begin_fill()
            drawCircle(radius)
            end_fill()

def randomCircleGrid(width, height, radius):
    for row in range(height):
        for col in range(width):
            x, y = gridCoordinates(row, col, radius)
            color(random.choice(colors))
            teleport(x, y)
            begin_fill()
            drawCircle(radius)
            end_fill()

def centeredCircleGrid(width, height, radius):
    offsetX = (width * 2 * radius) / 2 - radius
    offsetY = (height * 2 * radius) / 2 - radius
    for row in range(height):
        for col in range(width):
            x, y = gridCoordinates(row, col, radius)
            color(random.choice(colors))
            teleport(x - offsetX, y - offsetY)
            begin_fill()
            drawCircle(radius)
            end_fill()

def triangleOfCircles(width, height, radius):
    offsetX = (width * radius * 2) / 2 - radius
    offsetY = (height * radius * 2) / 2 - radius
    for row in range(height):
        for col in range(width):
            if row <= col:
            # For alternate diagonals:
            #if row + col <= 4:
                x, y = gridCoordinates(row, col, radius)
                color(random.choice(colors))
                teleport(x - offsetX, y - offsetY)
                begin_fill()
                drawCircle(radius)
                end_fill()


if __name__ == "__main__":
    # Test for the blueCircleGrid function:
    reset()
    noTrace()
    blueCircleGrid(3, 3, 50)
    showPicture()

    input('-->')

    reset()
    noTrace()
    randomCircleGrid(3, 3, 50)
    showPicture()

    input('-->')

    reset()
    noTrace()
    centeredCircleGrid(5, 5, 50)
    showPicture()

    input('-->')

    reset()
    noTrace()
    triangleOfCircles(5, 5, 50)
    showPicture()

    input('-->')
